#!/usr/bin/env python
# -*- coding: utf-8 -*-

# Find min/max values in a drawable

# (c) Ofnuts 2015
#
#   History:
#
#   v0.0: 2015-11-02: Initial version
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


import sys, os
from gimpfu import *

def minmax(image,drawable):
	lo=0
	hi=255
	while hi - lo > 1:
            test=(lo+hi)/2
            _, _, _, pixels, count, _ = pdb.gimp_histogram(drawable,HISTOGRAM_VALUE, 0,test)
            if pixels != count:
                lo=test
            else:
                hi=test
        maxvalue=hi-1
        lo=0
        hi=255
        while hi - lo > 1:
            test=(lo+hi)/2
            _, _, _, pixels, count, _ = pdb.gimp_histogram(drawable,HISTOGRAM_VALUE, test,255)
            if pixels != count:
                hi=test
            else:
                lo=test
        minvalue=lo+1
        gimp.message('Min: %d, max: %d' % (minvalue,maxvalue)) 

### Registration
whoiam='\n'+os.path.abspath(sys.argv[0])
author='Ofnuts'
copyrightYear='2015'
desc='Find min and max values in drawable'
register(
	'ofn-minmax',
	desc+whoiam,desc,
	author,author,
	copyrightYear,
	desc+'...',
	'RGB*,GRAY*',
	[
		(PF_IMAGE, 'image', 'Input image', None),
		(PF_DRAWABLE, 'drawable', 'Input drawable', None),
	],
	[],
	minmax,
	menu='<Image>/Filters'
)

main()